// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "AboutDlg.h"
#include "MainWnd.h"
#include "MainHelper.h"
#include "AutoUpdater.h"
#include "version.ver"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd *pMainFrame;
extern Helper m_Helper;

CAboutDlg *AboutDialog = NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog


CAboutDlg::CAboutDlg(UINT id, CWnd *pParent) : CDialog(id, pParent) {
}

CAboutDlg::~CAboutDlg() {
    AboutDialog = NULL;
}

CAboutDlg * CAboutDlg::getInstance(UINT id, CWnd *pParent) {
    if(AboutDialog != NULL && AboutDialog->m_hWnd != NULL)
        AboutDialog->DestroyWindow();
    if(AboutDialog != NULL && AboutDialog->m_hWnd == NULL) {
        delete AboutDialog;
        AboutDialog = NULL;
    }
    if(AboutDialog == NULL) {
        AboutDialog = new CAboutDlg(id, pParent);
        AboutDialog->Create(id, pParent);
    }
    else
        AboutDialog->SetFocus();
    return AboutDialog;
}
IMPLEMENT_MENUXP(CAboutDlg, CDialog);

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  ON_BN_CLICKED(IDC_BUTTON_MAIL, OnButtonMail)
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDC_BUTTON_HOMEPAGE, OnButtonHomepage)
  ON_BN_CLICKED(IDC_BUTTON_UPDATENOW, OnButtonUpdateNow)
  ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

void CAboutDlg::DoDataExchange(CDataExchange *pDX) {
    CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_BUTTON_HOMEPAGE, m_btnInternet);
    DDX_Control(pDX, IDC_BUTTON_MAIL, m_btnMail);
	DDX_Control(pDX, IDC_BUTTON_UPDATENOW, m_btnUpdateNow);
    DDX_Control(pDX, IDOK, m_btnOk);
}
void CAboutDlg::OnButtonHomepage() {
    ShellExecute(NULL, _T("open"), _T("http://micksebire.free.fr/"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnButtonMail() {
    ShellExecute(NULL, NULL, _T("mailto:micksebire@yahoo.fr"), NULL, NULL, SW_SHOWNORMAL);
}
void CAboutDlg::OnButtonUpdateNow() {
	CAutoUpdater updater;
	CAutoUpdater::ErrorType err = updater.CheckForUpdate(_T("http://micksebire.free.fr/"));
	switch(err) {
		case CAutoUpdater::Success:
			MessageBox(m_Helper.MyLoadString(IDS_UPDATEOK), _T("STP"), MB_ICONINFORMATION|MB_OK);
			pMainFrame->OnPopupMenuExit();
		break;
		case CAutoUpdater::UpdateNotRequired:
			MessageBox(m_Helper.MyLoadString(IDS_UPDATENOTREQUIRED), _T("STP"), MB_ICONINFORMATION|MB_OK);
		break;
		case CAutoUpdater::UpdateNotComplete:
			MessageBox(m_Helper.MyLoadString(IDS_UPDATEKO), _T("STP"), MB_ICONINFORMATION|MB_OK);
		break;
		case CAutoUpdater::NoExecutableVersion:
			MessageBox(m_Helper.MyLoadString(IDS_UPDATENOEXECUTABLEVERSION), _T("STP"), MB_ICONINFORMATION|MB_OK);
		break;
		default:
			MessageBox(m_Helper.MyLoadString(IDS_UPDATECONNECTFAILED), _T("STP"), MB_ICONINFORMATION|MB_OK);
		break;
	}
}

int CAboutDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) {
    return CDialog::OnCreate(lpCreateStruct);
}

BOOL CAboutDlg::OnInitDialog() {
    CDialog::OnInitDialog();

    m_Helper.translateWindowText(this, IDD_ABOUT);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_MAIL);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_HOMEPAGE);
    m_Helper.translateDlgItemText(this, IDC_BUTTON_UPDATENOW);
    m_Helper.translateDlgItemText(this, IDOK);
	CString title,version;
	this->GetWindowText(title);
	version.Format(_T("%s %d.%d.%d.%d"),title,VERSION_MAJOR,VERSION_MINOR,VERSION_BUILD,VERSION_QFE);
	this->SetWindowText(version);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

