// Helper.cpp: implementation of the Helper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "MainHelper.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSysTrayPlayApp theApp;
extern CMainWnd *pMainFrame;
extern Helper m_Helper;

Helper::Helper() {
}

void Helper::translate(UINT ressources, CString &buf, UINT i, UINT j) {
    CString oldValue = buf;
    CString key = "";
	CString tmp;
    TCHAR cbuf[256];

    key.Format(_T("%d"), ressources);
    if(j != 0xFFFFFFFF)
        key.Format(_T("%dI%dJ%d"), ressources, i, j);
    int translate = AfxGetApp()->GetProfileInt(_T("Preferences"), _T("MakeTranslation"), TRUE);

    CString langFile = AfxGetApp()->GetProfileString(_T("Preferences"), _T("Language"), _T(""));
    CString langFilePath = "";

    if(langFile.GetLength() != 0) {
        TCHAR buf[MAX_PATH + 1];
        CString name = _T("");
        GetModuleFileName(theApp.m_hInstance, buf, MAX_PATH);
        name.Format(_T("%s"), buf);
        name = name.Left(name.ReverseFind('.'));
        langFilePath.Format(_T("%s_%s.ini"), name, langFile);
    }
    pMainFrame->Language = langFile;

    if(translate == TRUE && langFile.GetLength() != 0)
		tmp = key + _T(" ") + oldValue;
    else
		tmp = oldValue;
    ::GetPrivateProfileString(_T("Translation"), key, tmp, cbuf, 256, langFilePath);
	if(tmp.Find(cbuf)==0)
		::WritePrivateProfileString(_T("Translation"), key, oldValue, langFilePath);

    buf.Format(_T("%s"), cbuf);
    buf.Replace(_T("\\n"), _T("\n"));
    buf.Replace(_T("\\t"), _T("\t"));
    buf.TrimRight();
}

void Helper::translateDlgItemText(CWnd *wnd, UINT itemID) {
    CString buf = "";

    wnd->GetDlgItemText(itemID, buf);
    m_Helper.translate(itemID, buf);
    wnd->SetDlgItemText(itemID, buf);
}

void Helper::translateMenu(CMenu *firstMenu, UINT firstMenuID) {
    UINT i, j;
    CObArray listMenu;
    listMenu.Add(firstMenu);
    for(j = 0; j < (UINT) listMenu.GetSize(); j++) {
        CMenu *menu = (CMenu *) listMenu[j];
        for(i = 0; i < menu->GetMenuItemCount(); i++) {
            UINT menuID = menu->GetMenuItemID(i);
            CString buf;
            if(menuID != 0) {
                menu->GetMenuString(i, buf, MF_BYPOSITION);
                if(menuID == 0xFFFFFFFF) {
                    CMenu *tmp = menu->GetSubMenu(i);
                    listMenu.Add(tmp);
                    m_Helper.translate(firstMenuID, buf, i, j);
                    HMENU tmpHMENU = tmp->GetSafeHmenu();
                    menu->RemoveMenu(i, MF_BYPOSITION);
                    menu->InsertMenu(i, MF_BYPOSITION | MF_POPUP, (UINT) tmpHMENU, buf);
                    //menu->GetSubMenu(i)->Attach(tmpHMENU);
                    //menu->ModifyMenu(i, MF_BYPOSITION, i, buf);
                }
                else {
                    m_Helper.translate(menuID, buf);
                    menu->ModifyMenu(menuID, MF_BYCOMMAND, menuID, buf);
                }
            }
        }
    }
}

void Helper::translateWindowText(CWnd *wnd, UINT windowID) {
    CString buf = "";
    wnd->GetWindowText(buf);
    m_Helper.translate(windowID, buf);
    wnd->SetWindowText(buf);
}

CString Helper::translateWindowTextString(CWnd *wnd, UINT windowID) {
    CString buf = "";
    wnd->GetWindowText(buf);
    m_Helper.translate(windowID, buf);
    return buf;
}

CString Helper::MyLoadString(UINT id) {
    CString buf;
    buf.LoadString(id);
    m_Helper.translate(id, buf);
    return buf;
}
