/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/
#ifndef SASCREVALFUNCSEXH
#define SASCREVALFUNCSEXH

#include "SAScrOper.h"
#include "SAScrEvalFunc.h"

//////////////////////////////////////////////////////
// new operators
extern VarEvalFunc __operCurDateString;
extern VarEvalFunc __operCurTimeString;

extern VarEvalFunc __operFileDateString;
extern VarEvalFunc __operFileTimeString;
extern VarEvalFunc __operFileSizeBString;
extern VarEvalFunc __operFileSizeKString;
extern VarEvalFunc __operFileExists;

extern VarEvalFunc __operConcat3;
extern VarEvalFunc __operQuoteStr;


//////////////////////////////////////////////////////
// utility functions
class SAScrEx
{
public:
   static CSAString	GetFileDateOnlyString(const CSAString &csFQSrcPath, bool bMod = false);
   static CSAString	GetFileTimeOnlyString(const CSAString &csFQSrcPath, bool bMod = false);
   static CSAString	GetFileSizeString(const CSAString &csFQSrcPath);
   static CSAString	GetFileSizeStringB(const CSAString &csFQSrcPath);
   static CSAString  GetCurTimeString();
   static CSAString  GetCurDateString();
   static CSAString  DateString(time_t t);
   static CSAString  GetFileDateString(const CSAString &csFQSrcPath, bool bMod);
};

#endif