/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/
#ifndef VAROPERATORMGRH
#define VAROPERATORMGRH

#include "SAScrDefs.h"
#include "SAScrMacros.h"
#include "SAScrVariable.h"
#include "SAScrOper.h"

class CSAScrOpManager
{
public:
   CSAScrOpManager();
   ~CSAScrOpManager();

   bool IsInit() const     {return m_bMapsInit;}
   bool Initialize(CSAMacroMap &macros, CSAScrVariableMap &vars);
   
   CSAScrOperatorMap m_operatorMap;    // pre-defined operators
   CSAScrVariableMap m_variableMap;    // pre-defined variables

protected:

   // add built-in variables
   void InitVariableMap(CSAScrVariableMap &userVariableMap);

   // add built-in operators
   void InitOperatorMap(CSAMacroMap &userMacroMap);
   
   // add non-core operators. this lives in SAScrEvalFuncsEx.cpp
   void InitOperatorMapEx(CSAScrOperatorMap& operMap);

   // are we ready?
   bool        m_bMapsInit;
};

// the one and only operator manager
extern CSAScrOpManager g_varOperManager;

#endif