/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/
#ifndef VARSTRUCTH
#define VARSTRUCTH

#pragma warning(disable:4786)
#include <map>

using namespace std ;
using namespace std::rel_ops ;

#include "SAScrString.h"

////////////////////////////////////////////////////////////////

struct CSAScrVariable
{
   CSAScrVariable();

   CSAScrVariable(CSAString pName, CSAString pDesc, CSAString pVal, unsigned long dwCtxt);

   // variable name
	CSAString pVarName;

   // to show users
	CSAString m_csDescription;

   // holds the value
   CSAString pValue;

   // context mask 
   unsigned long       dwContext;

#ifdef _DEBUG
   void Dump();
#else
	_inline void Dump() {}
#endif
};

////////////////////////////////////////////////////////////////

class CSAScrVariableMap : public map<CSAString, CSAScrVariable>
{
public:
   void Add(const TCHAR *pName, const TCHAR *pValue, unsigned long dwContext);
   void Add(const TCHAR *pName, const TCHAR *pDesc, const TCHAR *pValue, unsigned long dwContext);
   void Add(const CSAScrVariable &);

#ifdef _DEBUG
   void Dump();
#else
	_inline void Dump() {}
#endif

};

////////////////////////////////////////////////////////////////

extern bool operator < (const CSAScrVariable &a, const CSAScrVariable &b);
extern bool operator == (const CSAScrVariable &a, const CSAScrVariable &b);

////////////////////////////////////////////////////////////////

#endif