// SettingGeneral.cpp : fichier d'implmentation
//

#include "resource.h"
#include "stdafx.h"
#include "AboutDlg.h"
#include "AutDlg.h"
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogGeneral.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "Hotkeys.h"
#include "W2File.h"
#include "SeekDialog.h"
#include "EqualizerDlg.h"
#include "MP3InfoDlg.h"
#include "PlaylistDlg.h"
#include "In/MultiDllInput.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern Console *pConsole;
extern CSysTrayPlayApp theApp;
extern CMainWnd *pMainFrame;
extern Helper m_Helper;
extern CSettingsDialog *SettingsDialog;
extern CSeekDialog *SeekDialog;
extern CAboutDlg *AboutDialog;
extern CAutDlg *AutDlg;
extern CEqualizerDlg *EqualizerDlg;
extern CMP3InfoDlg *MP3InfoDlg;
extern CPlaylistDlg *PlaylistDlg;
extern CMultiDllInput *stdIn;

// Bote de dialogue CSettingGeneral

IMPLEMENT_MENUXP(CSettingsDialogGeneral, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogGeneral, CPropertyPage)

BOOL DeleteKeyAndSubKeys(HKEY    hkIn, LPCTSTR   pszSubKey) {
    HKEY hk;
    TCHAR szTmp[MAX_PATH];
    long l;
    BOOL f;

    l = RegOpenKeyEx(hkIn, pszSubKey, 0, KEY_ALL_ACCESS, &hk);
    if(l != ERROR_SUCCESS)
        return FALSE;

    f = TRUE;
    while(f) {
        l = RegEnumKey(hk, 0, szTmp, MAX_PATH);
        if(l != ERROR_SUCCESS)
            break;
        f = DeleteKeyAndSubKeys(hk, szTmp);
    }

    RegCloseKey(hk);
    l = RegDeleteKey(hkIn, pszSubKey);

    return (l == ERROR_SUCCESS) ? TRUE : FALSE;
}

void CSettingsDialogGeneral::CreateContMenus() {
    DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Play"));
    DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Add"));
    DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Play"));
    DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Add"));

    HKEY q;
    CString buf;

    TCHAR fname[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH);

    if(((CButton *) GetDlgItem(IDC_CM_PLAY))->GetCheck() == 1) {
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Play"), &q);
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)m_Helper.MyLoadString(IDS_PLAYWITHSTP).GetString(),
                      m_Helper.MyLoadString(IDS_PLAYWITHSTP).GetLength());
        RegCloseKey(q);
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Play\\Command"), &q);
        buf = fname;
        buf = _T("\"") + buf + _T("\"");
        buf += _T(" \"%1\"");
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)buf.GetString(), buf.GetLength() + 1);
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Play"), &q);
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)m_Helper.MyLoadString(IDS_PLAYWITHSTP).GetString(),
                      m_Helper.MyLoadString(IDS_PLAYWITHSTP).GetLength());
        RegCloseKey(q);
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Play\\Command"), &q);
        buf = fname;
        buf = _T("\"") + buf + _T("\"");
        buf += _T(" %1");
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)buf.GetString(), buf.GetLength() + 1);
        RegCloseKey(q);
    }
    if(((CButton *) GetDlgItem(IDC_CM_ADD))->GetCheck() == 1) {
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Add"), &q);
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetString(),
                      m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetLength());
        RegCloseKey(q);
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Add\\Command"), &q);
        buf = fname;
        buf = _T("\"") + buf + _T("\"");
        buf += _T(" \"%1\"");
        buf += _T(" -a");
        RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)buf.GetString(), buf.GetLength() + 1);
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Add"), &q);
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetString(),
                      m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetLength());
        RegCloseKey(q);
        RegCreateKey(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Add\\Command"), &q);
        buf = fname;
        buf = _T("\"") + buf + _T("\"");
        buf += _T(" %1");
        buf += _T(" -a");
		RegSetValueEx(q, _T(""), 0, REG_SZ, (LPBYTE)buf.GetString(), buf.GetLength() + 1);
        RegCloseKey(q);
    }
}

CSettingsDialogGeneral::CSettingsDialogGeneral() : CPropertyPage(CSettingsDialogGeneral::IDD) {
    m_tpc = pMainFrame->TPC;
}

CSettingsDialogGeneral::~CSettingsDialogGeneral() {
}


void CSettingsDialogGeneral::DoDataExchange(CDataExchange *pDX) {
    CPropertyPage::DoDataExchange(pDX);
    CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
    DDX_Text(pDX, IDC_TPC, m_tpc);
    DDX_Control(pDX, IDC_L_OPTIONS, m_l_options);
    DDX_Control(pDX, IDC_L_OPTIONS2, m_l_options2);
    DDX_Control(pDX, IDC_CHANGELANGUAGE, m_cbxLanguage);
    DDX_Control(pDX, IDC_HOTKEYS, m_BtnHotkeys);
    DDX_Control(pDX, IDC_SKIN, m_btnSkin);
    DDX_Control(pDX, IDC_W2F, m_btnW2F);
}

void CSettingsDialogGeneral::OnW2f() {
    CW2File dlg(IDD_W2FILE);
    dlg.DoModal();
}

void CSettingsDialogGeneral::OnHotkeys() {
    CHotkeys dlg(IDD_HOTKEYS);
    dlg.DoModal();
}

int CSettingsDialogGeneral::OnCreate(LPCREATESTRUCT lpCreateStruct) {
    m_Helper.translateWindowText(this, IDD_SETTINGS_GENERAL);
    return CPropertyPage::OnCreate(lpCreateStruct);
}

BOOL CSettingsDialogGeneral::OnInitDialog() {
    CPropertyPage::OnInitDialog();

    m_Helper.translateWindowText(this, IDD_SETTINGS_GENERAL);
    m_Helper.translateDlgItemText(this, IDC_LTRACKPERCOLUMN);
    m_Helper.translateDlgItemText(this, IDC_LPRESSHOLD);
    m_Helper.translateDlgItemText(this, IDC_LUSECLICKS);
    m_Helper.translateDlgItemText(this, IDC_LSETUP);
    m_Helper.translateDlgItemText(this, IDC_LPLAYWITH);
    m_Helper.translateDlgItemText(this, IDC_LFOLDERMENU);
    m_Helper.translateDlgItemText(this, IDC_CM_PLAY);
    m_Helper.translateDlgItemText(this, IDC_CM_ADD);
    m_Helper.translateDlgItemText(this, IDC_ADDBYDEF);
    m_Helper.translateDlgItemText(this, IDC_HOTKEYS);
    m_Helper.translateDlgItemText(this, IDC_SKIN);
    m_Helper.translateDlgItemText(this, IDC_W2F);
    m_Helper.translateDlgItemText(this, IDC_LADDITIONAL);
    m_Helper.translateDlgItemText(this, IDC_LLANGUAGE);

    m_tpc = pMainFrame->TPC;
    ((CSpinButtonCtrl *) GetDlgItem(IDC_SPIN2))->SetRange(0, 100);

    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION0));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION1));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION7));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION2));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION3));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION4));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION8));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION6));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION9));
    m_l_options.AddString(m_Helper.MyLoadString(IDS_OPTION10));

    m_l_options.SetCheck(0, pMainFrame->ShowGradientBar ? 1 : 0);
    m_l_options.SetCheck(1, pMainFrame->GraphicalButtons ? 1 : 0);
    m_l_options.SetCheck(2, pMainFrame->XPLookNFeel ? 1 : 0);
    m_l_options.SetCheck(3, pMainFrame->SMTracks ? 1 : 0);
    m_l_options.SetCheck(4, pMainFrame->SMAlbum ? 1 : 0);
    m_l_options.SetCheck(5, pMainFrame->AutoPlay);
    m_l_options.SetCheck(6, pMainFrame->SMPrevNext ? 1 : 0);
    m_l_options.SetCheck(7, pMainFrame->WAEmu ? 1 : 0);
    m_l_options.SetCheck(8, pMainFrame->autoUpdate ? 1 : 0);
    m_l_options.SetCheck(9, pMainFrame->displayConsole ? 1 : 0);

	CString extList = stdIn->GetFileExtensions();
	CString ext;
	int pos=0,i=0;

	ext = extList.Tokenize(_T(";"),pos);
	while(ext != "") {
		if(extList.Find(ext,pos) != -1) {
			ext = extList.Tokenize(_T(";"),pos);
			continue;
		}
		m_l_options2.AddString(ext);

		if (ReadFileTypes(ext))
			m_l_options2.SetCheck(i,1);
		else
			m_l_options2.SetCheck(i,0);
		ext = extList.Tokenize(_T(";"),pos);
		i++;
	}

    CFileFind finder;
    TCHAR buf[MAX_PATH + 1];
    CString directory = "";
    CString name = "";
    CString language = "";

    GetModuleFileName(theApp.m_hInstance, buf, MAX_PATH);
    directory.Format(_T("%s"), buf);
    directory = directory.Left(directory.ReverseFind('\\') + 1);
    name.Format(_T("%s"), buf);
    name = name.Right(name.GetLength() - name.ReverseFind('\\') - 1);
    name = name.Left(name.ReverseFind('.'));

    m_cbxLanguage.AddString(_T("en"));
    BOOL bWorking = finder.FindFile(directory + name + _T("_*.ini"));
    while(bWorking) {
        bWorking = finder.FindNextFile();
        language = finder.GetFilePath();
        language = language.Right(language.GetLength() - language.ReverseFind('_') - 1);
        language = language.Left(language.ReverseFind('.'));
        m_cbxLanguage.AddString(language);
    }
    m_cbxLanguage.SetCurSel(0);
    CString tmp;

    for(int i = 0; i < m_cbxLanguage.GetCount(); i++) {
        m_cbxLanguage.GetLBText(i, tmp);
        if(pMainFrame->Language.Find(tmp) != -1) {
            m_cbxLanguage.SetCurSel(i);
            break;
        }
    }
    ReadContMenus();

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogGeneral::OnOK() {
    UpdateData(TRUE);
    pMainFrame->TPC = m_tpc;

    pMainFrame->ShowGradientBar = m_l_options.GetCheck(0) == 1;
    pMainFrame->GraphicalButtons = m_l_options.GetCheck(1) == 1;
	if(pMainFrame->XPLookNFeel != (m_l_options.GetCheck(2) == 1))
		pMainFrame->needToRestart=true;
    pMainFrame->XPLookNFeel = (m_l_options.GetCheck(2) == 1);
    CMenuXP::SetXPLookNFeel(pMainFrame, pMainFrame->XPLookNFeel);
    pMainFrame->SMTracks = m_l_options.GetCheck(3) == 1;
    pMainFrame->SMAlbum = m_l_options.GetCheck(4) == 1;
    pMainFrame->AutoPlay = m_l_options.GetCheck(5);
    pMainFrame->SMPrevNext = m_l_options.GetCheck(6) == 1;
#ifndef _UNICODE
	if(pMainFrame->WAEmu != (m_l_options.GetCheck(7) == 1))
		pMainFrame->needToRestart = true;
#else
	if(m_l_options.GetCheck(7) == 1)
		AfxMessageBox(m_Helper.MyLoadString(IDS_OPTION6) +_T("\n")+ m_Helper.MyLoadString(IDS_UNICODEERROR), MB_OK | MB_ICONERROR);
#endif
	pMainFrame->WAEmu = m_l_options.GetCheck(7) == 1;
    pMainFrame->autoUpdate = m_l_options.GetCheck(8) == 1;
	pMainFrame->displayConsole = m_l_options.GetCheck(9) == 1;

    CString tmp;

    m_cbxLanguage.GetLBText(m_cbxLanguage.GetCurSel(), tmp);
    if(tmp.Find(_T("en")) != -1)
        theApp.WriteProfileString(_T("Preferences"), _T("Language"), _T(""));
    else
        theApp.WriteProfileString(_T("Preferences"), _T("Language"), tmp);

    RegFileTypes();
    CreateContMenus();
	
	if(pMainFrame->displayConsole) 
		pConsole->Popup();

    CPropertyPage::OnOK();
}

void CSettingsDialogGeneral::OnPopupLoad() {
    // open a skin file
    CFileDialog dialog(TRUE, _T("skn"), _T(""), OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, m_Helper.MyLoadString(IDS_OPENSKIN));
    TCHAR buf[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, buf, MAX_PATH);
    for(int i = _tcslen(buf) - 1; i > 0; i--) {
        if(buf[i] == '\\') {
            buf[i + 1] = '\0';break;
        }
    }
    dialog.m_ofn.lpstrInitialDir = buf;
    int ret;
    ret = dialog.DoModal();
    if(ret == IDOK) {
        pMainFrame->CurrentSkin = dialog.GetPathName();
        pMainFrame->LoadSkin();
        pMainFrame->ResetSkin();
    }
}

void CSettingsDialogGeneral::OnPopupUseDefault() {
    pMainFrame->CurrentSkin = "";
    pMainFrame->LoadSkin();
    pMainFrame->ResetSkin();
}

void CSettingsDialogGeneral::OnSkin() {
    CMenu menu;
    CMenu *pPopup;
    menu.LoadMenu(IDR_SKINPOPUP);
    pPopup = menu.GetSubMenu(0);
    m_Helper.translateMenu(pPopup, IDR_SKINPOPUP);
    CMenuXP::UpdateMenuBar(this);

    CRect rect;
    GetDlgItem(IDC_SKIN)->GetWindowRect(&rect);
    POINT point;
    point.x = (rect.left + rect.right) / 2;
    point.y = (rect.top + rect.bottom) / 2;
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CSettingsDialogGeneral::RegFileTypes() {
    TCHAR fname[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH);
    bool enqdef = (((CButton *) GetDlgItem(IDC_ADDBYDEF))->GetCheck() == 1);

    HKEY q;
    CString buf;
	for(int i=0;i<m_l_options2.GetCount();i++) {

		CString extension="";
		m_l_options2.GetText(i,extension);
		CString dotExtension = ".";
		dotExtension.Append(extension.MakeLower());

		CString key = _T("STP");
		key.Append(extension.MakeUpper());

		CString defaultIcon = key;
		defaultIcon.Append(_T("\\DefaultIcon"));
		CString shell = key;
		shell.Append(_T("\\Shell"));
		CString shellOpen = shell;
		shellOpen.Append(_T("\\Open"));
		CString shellOpenCommand = shellOpen;
		shellOpenCommand.Append(_T("\\Command"));
		CString shellAdd = shell;
		shellAdd.Append(_T("\\Add"));
		CString shellAddCommand = shellAdd;
		shellAddCommand.Append(_T("\\Command"));

		DeleteKeyAndSubKeys(HKEY_CLASSES_ROOT, key);

		// MP3, M3U, PLS
		if(m_l_options2.GetCheck(i) == 1) {
			RegCreateKey(HKEY_CLASSES_ROOT, dotExtension, &q);
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(key), key.GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, key, &q);
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(m_Helper.MyLoadString(IDS_MP3AUDIO)),
						m_Helper.MyLoadString(IDS_MP3AUDIO).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, defaultIcon, &q);
			buf = fname;
			buf += ",1";
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, shell, &q);
			if(enqdef)
				RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(m_Helper.MyLoadString(IDS_MENUADD)),
							m_Helper.MyLoadString(IDS_MENUADD).GetLength());
			else
				RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
							m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, shellOpen, &q);
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
						m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, shellOpenCommand, &q);
			buf = fname;
			buf = "\"" + buf + "\"";
			buf += " \"%1\"";
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, shellAdd, &q);
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(m_Helper.MyLoadString(IDS_ADDTOPLAYLIST)),
						m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, shellAddCommand, &q);
			buf = fname;
			buf = "\"" + buf + "\"";
			buf += " -a";
			buf += " \"%1\"";
			RegSetValueEx(q, _T(""), 0, REG_SZ, (unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);

/*
			RegCreateKey(HKEY_CLASSES_ROOT, ".m3u", &q);
			RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "STPM3U", sizeof("STPM3U"));
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, ".pls", &q);
			RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "STPM3U", sizeof("STPM3U"));
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U", &q);
			RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_M3UPLAYLIST)),
						m_Helper.MyLoadString(IDS_M3UPLAYLIST).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\DefaultIcon", &q);
			buf = fname;
			buf += ",2";
			RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell", &q);
			if(enqdef)
				RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUADD)),
							m_Helper.MyLoadString(IDS_MENUADD).GetLength());
			else
				RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
							m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Open", &q);
			RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
						m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Open\\Command", &q);
			buf = fname;
			buf = "\"" + buf + "\"";
			buf += " \"%1\"";
			RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);
			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Add", &q);
			RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_ADDTOPLAYLIST)),
						m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetLength());
			RegCloseKey(q);

			RegCreateKey(HKEY_CLASSES_ROOT, "STPM3U\\Shell\\Add\\Command", &q);
			buf = fname;
			buf = "\"" + buf + "\"";
			buf += " \"%1\"";
			buf += " -a";
			RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
			RegCloseKey(q);*/
		}
		else {/*
			if(PrevMP3) {
				RegCreateKey(HKEY_CLASSES_ROOT, ".mp3", &q);
				RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "", 0);
				RegCloseKey(q);

				RegCreateKey(HKEY_CLASSES_ROOT, ".m3u", &q);
				RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "", 0);
				RegCloseKey(q);

				RegCreateKey(HKEY_CLASSES_ROOT, ".pls", &q);
				RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "", 0);
				RegCloseKey(q);
			}*/
		}
	}
/*
    // WAV
    if(((CButton *) GetDlgItem(IDC_FT_WAV))->GetCheck() == 1) {
        RegCreateKey(HKEY_CLASSES_ROOT, ".wav", &q);
        RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "STPMP3", sizeof("STPMP3"));
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV", &q);
        RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_RIFFWAV)),
                      m_Helper.MyLoadString(IDS_RIFFWAV).GetLength());
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\DefaultIcon", &q);
        buf = fname;
        buf += ",1";
        RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell", &q);
        if(enqdef)
            RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUADD)),
                          m_Helper.MyLoadString(IDS_MENUADD).GetLength());
        else
            RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
                          m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Open", &q);
        RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_MENUOPEN)),
                      m_Helper.MyLoadString(IDS_MENUOPEN).GetLength());
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Open\\Command", &q);
        buf = fname;
        buf = "\"" + buf + "\"";
        buf += " \"%1\"";
        RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Add", &q);
        RegSetValueEx(q, "", 0, REG_SZ, (unsigned char *) LPCSTR(m_Helper.MyLoadString(IDS_ADDTOPLAYLIST)),
                      m_Helper.MyLoadString(IDS_ADDTOPLAYLIST).GetLength());
        RegCloseKey(q);

        RegCreateKey(HKEY_CLASSES_ROOT, "STPWAV\\Shell\\Add\\Command", &q);
        buf = fname;
        buf = "\"" + buf + "\"";
        buf += " \"%1\"";
        buf += " -a";
        RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
        RegCloseKey(q);
    }
    else {
        if(PrevWAV) {
            RegCreateKey(HKEY_CLASSES_ROOT, ".wav", &q);
            RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) "", 0);
            RegCloseKey(q);
        }
    }

    // CD
    if(((CButton *) GetDlgItem(IDC_FT_CD))->GetCheck() == 1) {
        RegCreateKey(HKEY_CLASSES_ROOT, "AudioCD\\Shell\\Play\\Command", &q);
        buf = fname;
        buf = "\"" + buf + "\"";
        buf += " -c";
        RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
        RegCloseKey(q);
    }
    else {
        if(PrevCD) {
            RegCreateKey(HKEY_CLASSES_ROOT, "AudioCD\\Shell\\Play\\Command", &q);
            buf = "cdplayer.exe /play %1";
            RegSetValueEx(q, "", 0, REG_SZ, (const unsigned char *) LPCTSTR(buf), buf.GetLength() + 1);
            RegCloseKey(q);
        }
    }
*/
}


void CSettingsDialogGeneral::ReadContMenus() {
    HKEY q;    
    unsigned long z, mp;

    bool PrevPlay = true, PrevAdd = true;

    TCHAR fname[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    CString mFile = _T("\"");
    mFile += fname;
    mFile += _T("\" \"%1\"");

    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Play\\Command"), 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(mFile.CompareNoCase(fname) != 0)
                PrevPlay = false;
        }
        else
            PrevPlay = false;
        RegCloseKey(q);
    }
    else
        PrevPlay = false;

    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    mFile = "\"";
    mFile += fname;
    mFile += "\" %1";
    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Play\\Command"), 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(mFile.CompareNoCase(fname) != 0)
                PrevPlay = false;
        }
        else
            PrevPlay = false;
        RegCloseKey(q);
    }
    else
        PrevPlay = false;

    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    mFile = "\"";
    mFile += fname;
    mFile += "\" \"%1\"";
    mFile += " -a";
    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Directory\\Shell\\Add\\Command"), 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(mFile.CompareNoCase(fname) != 0)
                PrevAdd = false;
        }
        else
            PrevAdd = false;
        RegCloseKey(q);
    }
    else
        PrevAdd = false;

    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    mFile = "\"";
    mFile += fname;
    mFile += "\" %1";
    mFile += " -a";
    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, _T("Drive\\Shell\\Add\\Command"), 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(mFile.CompareNoCase(fname) != 0)
                PrevAdd = false;
        }
        else
            PrevAdd = false;
        RegCloseKey(q);
    }
    else
        PrevAdd = false;

    if(PrevPlay)
        ((CButton *) GetDlgItem(IDC_CM_PLAY))->SetCheck(1);
    if(PrevAdd)
        ((CButton *) GetDlgItem(IDC_CM_ADD))->SetCheck(1);
}

bool CSettingsDialogGeneral::ReadFileTypes(CString ext) {
	CString dotExt = ".";
	dotExt.Append(ext.MakeLower());

	CString key = _T("STP");
	key.Append(ext.MakeUpper());

	CString shell = key;
	shell.Append(_T("\\Shell"));
	CString shellOpen = shell;
	shellOpen.Append(_T("\\Open"));
	CString shellOpenCommand = shellOpen;
	shellOpenCommand.Append(_T("\\Command"));
	CString shellAdd = shell;
	shellAdd.Append(_T("\\Add"));
	CString shellAddCommand = shellAdd;
	shellAddCommand.Append(_T("\\Command"));

    TCHAR fname[MAX_PATH + 1];
    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    CString mFile = "\"";
    mFile += fname;
    mFile += "\" -c";

    HKEY q;
    unsigned long z;
    unsigned long mp; 

    bool PrevMP3 = false;

    int qq = 0;
    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, dotExt, 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(_tcscmp(fname, key) == 0)
                qq++;
        }
        RegCloseKey(q);
    }

    if(qq == 1)
        PrevMP3 = true;

    if(RegOpenKeyEx(HKEY_CLASSES_ROOT, shell, 0, KEY_READ, &q) == ERROR_SUCCESS) {
        z = REG_SZ;mp = MAX_PATH;
        if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
            if(_tcscmp(fname, _T("Add")) == 0)
                ((CButton *) GetDlgItem(IDC_ADDBYDEF))->SetCheck(1);
        }
        RegCloseKey(q);
    }

    GetModuleFileName(theApp.m_hInstance, fname, MAX_PATH); 
    mFile = "\"";
    mFile += fname;
    mFile += "\" \"%1\"";

    if(PrevMP3) {
        if(RegOpenKeyEx(HKEY_CLASSES_ROOT, shellOpenCommand, 0, KEY_READ, &q) == ERROR_SUCCESS) {
            z = REG_SZ;mp = MAX_PATH;
            if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
                if(mFile.CompareNoCase(fname) != 0)
                    PrevMP3 = false;
            }
            else
                PrevMP3 = false;
            RegCloseKey(q);
        }
        else
            PrevMP3 = false;

        mFile += " -a";
		if(RegOpenKeyEx(HKEY_CLASSES_ROOT, shellAddCommand, 0, KEY_READ, &q) == ERROR_SUCCESS) {
            z = REG_SZ;mp = MAX_PATH;
            if(RegQueryValueEx(q, _T(""), NULL, &z, (LPBYTE) fname, &mp) == ERROR_SUCCESS) {
                if(mFile.CompareNoCase(fname) != 0)
                    PrevMP3 = false;
            }
            else
                PrevMP3 = false;
            RegCloseKey(q);
        }
        else
            PrevMP3 = false;
    }

	return PrevMP3;
}

BEGIN_MESSAGE_MAP(CSettingsDialogGeneral, CPropertyPage)
    ON_BN_CLICKED(IDC_HOTKEYS, OnHotkeys)
    ON_BN_CLICKED(IDC_SKIN, OnSkin)
    ON_BN_CLICKED(IDC_W2F, OnW2f)
    ON_COMMAND(ID_POPUP_LOAD, OnPopupLoad)
    ON_COMMAND(ID_POPUP_USEDEFAULT, OnPopupUseDefault)
    ON_WM_CREATE()
END_MESSAGE_MAP()
